//==================================================================================================
// BP5.BP5 - Core Gametype Class   4/21/13 - MrLoathsome
//==================================================================================================
class BP5 extends TeamGamePlus config;

var int CPCnt, ExtraCP, MonsterTeamNum, TCPCnt[4];
var bool bNeutralPoints, bTDM;
var config bool bDumbDown;		// reduce efficiency of bot team AI
var C2DCP ControlPoints[64];
var int DomScoreEvent;			// used to track when to dump out periodic stat information
var float  maxMapSize, ChkRad;
var Bot Dummy;
var() config int ExtraControlPoints;	// number of extra control points to add randomly
var() config bool bScoreSPKills;
var() config bool bNegScoring;
var() config bool bScoreTeamKills;
var() config bool bMonsterTeam;
var() config bool bScoreSPvsSP;
var() config int MonsterTeamNumber;

function PostBeginPlay()
{
	local NavigationPoint N;
	local Vector L, RL, v1, v2, PNA[2048];
	local C2DCP Dcp;
	local ControlPoint tmpCP;
	local Actor A;
	local pawn P;
	local int x, y, PNCnt;
	local float chkDist, XMax, XMin, YMax, YMin;

	bTDM = (!Level.Game.IsA('Domination'));
	FragLimit = GoalTeamScore;

	if (bMonsterTeam)
	{
		if (MonsterTeamNumber == 255)
		{
			MonsterTeamNum = MaxTeams;
		}
		else MonsterTeamNum = MonsterTeamNumber;
		MonsterTeamNum = FMin(MonsterTeamNum, MaxTeams);

		for (N = Level.NavigationPointList; N != NONE; N = N.NextNavigationPoint)
		{
			Dummy = Spawn(class'BotPack.TMale1Bot',,,N.Location);
			if (Dummy != None) break;
		}
		if (Dummy != None)
		{
			Dummy.PlayerReplicationInfo.PlayerID = Level.Game.CurrentID++;
			Level.Game.ChangeName(Dummy, "The Monsters", false);
			Dummy.PlayerReplicationInfo.Team = MonsterTeamNum;
			Dummy.Health = 0;
			Dummy.Orders='Hold';
			Dummy.GotoState('GameEnded');
			Dummy.bAutoActivate=False;
			Dummy.SightRadius=0.0;
			Dummy.HearingThreshold=0.0;
			Dummy.SetTimer(0, False);
			Dummy.bHidden = True;
		}
	}

	Super.PostBeginPlay();

	if ((bMonsterTeam) && (MonsterTeamNum == MaxTeams))
	{
		Teams[MonsterTeamNum] = Spawn(class'TeamInfo');
		Teams[MonsterTeamNum].Size = 1;
		Teams[MonsterTeamNum].Score = 0;
		if (MonsterTeamNum > 0) Teams[MonsterTeamNum].TeamName = "The Monster Team";
		Teams[MonsterTeamNum].TeamIndex = MonsterTeamNum;
		TournamentGameReplicationInfo(GameReplicationInfo).Teams[MonsterTeamNum] = Teams[MonsterTeamNum];
	} else if (bMonsterTeam)
		{
			AddToTeam(MonsterTeamNum, Dummy);
		}

	// **Credit to Feralidragon over at UT99.org for this next bit that calculates maxMapSize
	ForEach AllActors(Class'Actor', A)
	{
		if (PlayerStart(A) != None || Inventory(A) != None)
		{
			//Get max size (step 1/2)
			XMax = FMax(XMax, A.Location.X);
			XMin = FMin(XMin, A.Location.X);
			YMax = FMax(YMax, A.Location.Y);
			YMin = FMin(YMin, A.Location.Y);
		}
	}
	//Get max size (step 2/2)
	v1.X = XMax;
	v1.Y = YMax;
	v2.X = XMin;
	v2.Y = YMin;
	maxMapSize = VSize(v1 - v2);
	for (N = Level.NavigationPointList; N != NONE; N = N.NextNavigationPoint)
	{
		if (((N.IsA('FlagBase')) || (N.IsA('ControlPoint'))) && (CPCnt < 64))
		{
			L = N.Location;
			While ((Dcp == None) && (x < 255))
			{
				Dcp = spawn(class'C2DCP',,,L);
				++x;
			}
			if (Dcp != None)
			{
				Dcp.PointName = "   CP"@String(CPCnt + 1)$"   ";
				if (bTDM) { Dcp.bDOM = False; } else { Dcp.bDOM = True; }
				ControlPoints[CPCnt] = Dcp;
				if (N.IsA('ControlPoint'))
				{
					ControlPoint(N).bHidden = true;
					ControlPoint(N).Disable('Touch');
					ControlPoint(N).SetTimer(0.0, false);
					ControlPoint(N).SetPhysics(PHYS_None);
					ControlPoint(N).RemoteRole = ROLE_None;
					ControlPoint(N).SetCollision(false, false, false);
					ControlPoints[CPCnt].SetLocation(N.Location);
					ControlPoints[CPCnt].PointName = ControlPoint(N).GetHumanName();
				}
				if (bMonsterTeam) { AddCPDum(ControlPoints[CPCnt].Location, CPCnt); }
				++CPCnt;
				Dcp = None;
			}
		}
		else
		if (((N.IsA('PathNode')) || (N.IsA('InventorySpot'))) && (PNCnt < 2048))
		{
			PNA[PNCnt] = N.Location + (10 * VRand());
			PNCnt++;
		}
	}
	ExtraCP = ExtraControlPoints;
	if ((ExtraCP > 100) && (ExtraCP < 165)) ExtraCP = Rand(ExtraCP-100) + 1;
	ExtraCP = FMin(ExtraCP, 64 - CPCnt);
	ExtraCP = FMin(ExtraCP, PNCnt - CPCnt);
	Log("Default map bases: "$CPCnt@" Extra Points: "$ExtraCP);

	if (ExtraCP != 0)
	{
		if (CPCnt > 1)
			chkDist = (maxMapSize / CPCnt);
		else
			chkDist = maxMapSize * 0.5;
		for (x = 0; x<ExtraCP; x++)
		{
			y = 0; Dcp = None;
			while ((Dcp == None) && (y < 255))
			{
				L = PNA[Rand(PNCnt)]; L.z = L.z - 20;
				if (!NearCP(L, chkDist))
				{
					Dcp = spawn(class'C2DCP',,,L);
					if ((Dcp != None) && (!Dcp.Region.Zone.IsA('WaterZone')))
					{
						Dcp.PointName = "   CP"@String(CPCnt + 1)$"   ";
						if (bTDM) { Dcp.bDOM = False; } else { Dcp.bDOM = True; }
						ControlPoints[CPCnt] = Dcp;
						if (bMonsterTeam) AddCPDum(Dcp.Location, CPCnt);
						++CPCnt;
						y = 254;
					}
					else
						{ chkDist *= 0.9; }
				}
				else
					{ if (Dcp != None) { Dcp.Destroy(); } chkDist *= 0.9; }
				++y;
			}
			chkDist = (maxMapSize / CPCnt);
		}
	}
	if (CPCnt > 2) ChkRad = (maxMapSize / (CPCnt - 1)); else ChkRad = (maxMapSize * 0.50);
	ChkRad *= 1.20;
	log(maxMapSize@" - "@ChkRad);

	class'BP5.CDHUD'.default.CPCnt = FMin(CPCnt, 5);
	for (x = 0; x<FMin(CPCnt, 5); x++)
	{
		class'BP5.CDHUD'.default.CPA[x] = ControlPoints[x];
	}
	log("CPCnt: "$CPCnt@" #Possible Locations: "$PNCnt);

	if (!bTDM) GameName = String(CPCnt)@"Control Point "$GameName;
	TournamentGameReplicationInfo(GameReplicationInfo).GameName = GameName;
}

function AddCPDum(Vector Loc, int i)
{
	local CPDummy CPDtmp;

	CPDtmp = spawn(class'CPDummy',,, Loc);
	if (CPDtmp != None)
	{
		ControlPoints[i].CPDum = CPDtmp;
	}
	else { log("Dummy spawn failed..."); }
}

function bool NearCP(Vector Loc, float Rad)
{
	local ControlPoint C;

	ForEach RadiusActors(class'ControlPoint', C, Rad, Loc)
		{ return true; }
	return false;
}


function playerpawn Login
(
	string Portal,
	string Options,
	out string Error,
	class<playerpawn> SpawnClass
)
{
	local PlayerPawn NewPlayer;
	local NavigationPoint StartSpot;
	local int H;

	if ((bMonsterTeam) && (MonsterTeamNum == MaxTeams))
	{
		H = MaxTeams; MaxTeams--;
	}
	NewPlayer = Super.Login(Portal, Options, Error, SpawnClass);
	if (NewPlayer == None)
	{
		if ((bMonsterTeam) && (MonsterTeamNum == H)) { MaxTeams = H; }
		return None;
	}
	if ((bMonsterTeam) && (MonsterTeamNum == H))
	{
		MaxTeams = H;
	}

	if ( bSpawnInTeamArea )
	{
		StartSpot = FindPlayerStart(NewPlayer,NewPlayer.PlayerReplicationInfo.Team);
		if ( StartSpot != None )
		{
			NewPlayer.SetLocation(StartSpot.Location);
			NewPlayer.SetRotation(StartSpot.Rotation);
			NewPlayer.ViewRotation = StartSpot.Rotation;
			NewPlayer.ClientSetRotation(NewPlayer.Rotation);
			StartSpot.PlayTeleportEffect(NewPlayer, true);
		}
	}
	return NewPlayer;
}

function bool IsOnTeam(Pawn Other, int TeamNum)
{
	if (((Other.bIsPlayer) && (Other.PlayerReplicationInfo.Team == TeamNum)) || ((!Other.bIsPlayer) && (MonsterTeamNum == TeamNum)))
		return true;

	return false;
}

function byte AssessBotAttitude(Bot aBot, Pawn Other)
{
	if (!Other.bIsPlayer) return 1;
	else 
		return Super.AssessBotAttitude(aBot, Other);
}

function bool IsRelevant(Actor Other)
{
	if ((bMonsterTeam) && (Other.IsA('ScriptedPawn')))
	{
		if (!Other.IsA('Pupae')) ScriptedPawn(Other).Intelligence = BRAINS_HUMAN;
		ScriptedPawn(Other).Aggressiveness = 3.0;
		ScriptedPawn(Other).Skill = 3.0;
	}
	return Super.IsRelevant(Other);
}

function ScoreKill(pawn Killer, pawn Other)
{
	if (((killer == None) && (Other.bIsPlayer)) || ((killer != None) && (killer == Other) && (Other.bIsPlayer)))
		Other.PlayerReplicationInfo.Score -= 1;
	else if (killer != None)
	{
		if ( Killer.bIsPlayer && Other.bIsPlayer && (Killer.PlayerReplicationInfo.Team != Other.PlayerReplicationInfo.Team) )
			Killer.PlayerReplicationInfo.Score += 1;
		else
		if (!Other.bIsPlayer && Killer.bIsPlayer)
		{
			if (bScoreSPKills)
				Killer.PlayerReplicationInfo.Score += 1;
			else
				if (bNegScoring)
					Killer.PlayerReplicationInfo.Score -= 1;
		}
	}
   if ( bScoreTeamKills )
   {
	if ((!Other.bIsPlayer) && (Killer != None) && (Killer.bIsPlayer) && (Killer.PlayerReplicationInfo.Team != 255))
	{
		Teams[Killer.PlayerReplicationInfo.Team].Score += 1;
	}
	if ((Other.bIsPlayer) && (Killer != None) && (Killer.bIsPlayer))
	{
		if ((Killer.PlayerReplicationInfo.Team != Other.PlayerReplicationInfo.Team) && (Killer.PlayerReplicationInfo.Team != 255))
			Teams[Killer.PlayerReplicationInfo.Team].Score += 1;
		else if ((FriendlyFireScale > 0) &&  (Other.PlayerReplicationInfo.Team != 255))
		{
			Teams[Other.PlayerReplicationInfo.Team].Score -= 1;
			Killer.PlayerReplicationInfo.Score -= 1;
		}
	}
   }
	BaseMutator.ScoreKill(Killer, Other);
}

function Killed(pawn killer, pawn Other, name damageType)
{
	local int NextTaunt, i, wt, ts;
	local bool bAutoTaunt, bTie;

	if ((Killer != None) && (Killer != Other) && (other.PlayerReplicationInfo != None) && (killer.PlayerReplicationInfo != None))
	{
		if (damageType == 'Decapitated')
		{
			if ((Level.Game.LocalLog != None) && (Other.PlayerReplicationInfo != None))
				Level.Game.LocalLog.LogSpecialEvent("headshot", Killer.PlayerReplicationInfo.PlayerID, Other.PlayerReplicationInfo.PlayerID);
			if ((Level.Game.WorldLog != None) && (Other.PlayerReplicationInfo != None))
				Level.Game.WorldLog.LogSpecialEvent("headshot", Killer.PlayerReplicationInfo.PlayerID, Other.PlayerReplicationInfo.PlayerID);
		}
	}
	if ((Killer != None) && (killer.PlayerReplicationInfo != None) && (damageType == 'Decapitated') && (!Other.bIsPlayer))
		Killer.ReceiveLocalizedMessage( class'DecapitationMessage' );
	if (!bMonsterTeam || ((Killer != None) && (killer.PlayerReplicationInfo != None) && (Other.PlayerReplicationInfo != None)))
	{
		Super.Killed(killer, Other, damageType);
	}
	else
	{
		if ((Killer != None) && (killer.PlayerReplicationInfo == None) && (Killer != Other))
		{
			if (bMonsterTeam)
			{
				Dummy.PlayerReplicationInfo.PlayerName = Killer.GetHumanName();
				if ((Other.bIsPlayer) && (!Killer.IsA('StationaryPawn'))) ScoreKill(Dummy, Other);
			}
			Super(GameInfo).Killed(killer, Other, damageType);
			if ((!bFirstBlood) && (Other.PlayerReplicationInfo != None) && (!Killer.bIsPlayer) && (!Self.IsA('TrainingDM')))
			{
				bFirstBlood = True;  PlayerPawn(Other).ServerReStartPlayer();
				if (bMonsterTeam) BroadcastLocalizedMessage( class'FirstBloodMessage', 0, Dummy.PlayerReplicationInfo );
			}
			if (bMonsterTeam && bScoreSPvsSP && !Other.bIsPlayer && !Killer.IsA('StationaryPawn'))
			{
				Dummy.PlayerReplicationInfo.Score += 1; Teams[Dummy.PlayerReplicationInfo.Team].Score += 1;
			}
			if (bMonsterTeam)
			{
				Dummy.PlayerReplicationInfo.PlayerName = "The Monsters";
			}
		}
		else
		{
			Super(GameInfo).Killed(killer, Other, damageType);
		}
	}

		if ( bOverTime )
		{
			bTie = false;
			//check for clear winner now
			// find team winner
			for ( i=0; i<4; i++ )
				if (Teams[i].Score > ts)
					{ wt = i; ts = Teams[i].Score; }

			// check for tie
			for ( i=0; i<4; i++ )
				if ((i != wt) && (Teams[i].Score == ts))
					bTie = true;
			if ( !bTie )
			{
				if (GoalTeamScore > 0)
				{
					if ((killer != None) && (!killer.bIsPlayer) && (bMonsterTeam))
						Dummy.PlayerReplicationInfo.PlayerName = "The Monsters";
					EndGame("teamscorelimit");
				}
			}
		}
		else if ((FragLimit > 0) && (killer != None) && (killer.PlayerReplicationInfo != None)
				 && (Killer.PlayerReplicationInfo.Team != 255) && (Teams[Killer.PlayerReplicationInfo.Team].Score >= FragLimit))
			{ EndGame("fraglimit"); }
			else if ((FragLimit > 0) && (killer != None) && (!killer.bIsPlayer) && (bMonsterTeam)
					&& (Teams[Dummy.PlayerReplicationInfo.Team].Score >= FragLimit))
				{ Dummy.PlayerReplicationInfo.PlayerName = "The Monsters"; EndGame("fraglimit"); }

		if (bMonsterTeam && (Other.PlayerReplicationInfo == None))
		{
			if ( Dummy.Spree > 4 )
				EndSpree(Killer, Dummy); 
			Dummy.Spree = 0;
		}
		else
		{
			if ( Other.Spree > 4 )
				EndSpree(Killer, Other); 
			Other.Spree = 0;
		}

		if ((killer == None) || (Other == None) || ((Killer != None) && (Killer.IsA('StationaryPawn'))))
			return;

		if ( !bFirstBlood )
			if ((Killer.bIsPlayer && (Killer != Other)) || (!Killer.bIsPlayer && bMonsterTeam && (Killer != Other)))
				if (!Self.IsA('TrainingDM'))
				{
					bFirstBlood = True;
					if (!Killer.bIsPlayer && bMonsterTeam)
						BroadcastLocalizedMessage( class'FirstBloodMessage', 0, Dummy.PlayerReplicationInfo );
					else
						BroadcastLocalizedMessage( class'FirstBloodMessage', 0, Killer.PlayerReplicationInfo );
				}

		if ( BotConfig.bAdjustSkill && (killer.IsA('PlayerPawn') || Other.IsA('PlayerPawn')) )
		{
			if ( killer.IsA('Bot') )
				BotConfig.AdjustSkill(Bot(killer),true);
			if ( Other.IsA('Bot') )
				BotConfig.AdjustSkill(Bot(Other),false);
		}
		if (bMonsterTeam && (Killer.PlayerReplicationInfo == None) && (Killer != Other))
		{
			Dummy.Spree++;
			if ( Dummy.Spree > 4 )
				NotifySpree(Dummy, Dummy.Spree);
		}
		else
		if ( Other.bIsPlayer && (Killer != None) && Killer.bIsPlayer && (Killer != Other) 
			&& (!bTeamGame || (Other.PlayerReplicationInfo.Team != Killer.PlayerReplicationInfo.Team)) )
			{
				Killer.Spree++;
				if ( Killer.Spree > 4 )
				NotifySpree(Killer, Killer.Spree);
			} 

		bAutoTaunt = ((TournamentPlayer(Killer) != None) && TournamentPlayer(Killer).bAutoTaunt);
		if ( ((Bot(Killer) != None) || bAutoTaunt)
			&& (Killer != Other) && (DamageType != 'gibbed') && (Killer.Health > 0)
			&& (Level.TimeSeconds - LastTauntTime > 3) )
		{
			LastTauntTime = Level.TimeSeconds;
			NextTaunt = Rand(class<ChallengeVoicePack>(Killer.PlayerReplicationInfo.VoiceType).Default.NumTaunts);
			for ( i=0; i<4; i++ )
			{
				if ( NextTaunt == LastTaunt[i] )
					NextTaunt = Rand(class<ChallengeVoicePack>(Killer.PlayerReplicationInfo.VoiceType).Default.NumTaunts);
				if ( i > 0 )
					LastTaunt[i-1] = LastTaunt[i];
			}	
			LastTaunt[3] = NextTaunt;
	 		killer.SendGlobalMessage(None, 'AUTOTAUNT', NextTaunt, 5);
		}
		if ( bRatedGame )
			RateVs(Other, Killer);
}

function InitRatedGame(LadderInventory LadderObj, PlayerPawn LadderPlayer)
{
	bDumbDown = True;
	Super.InitRatedGame(LadderObj, LadderPlayer);
}

function bool SetEndCams(string Reason)
{
	local TeamInfo BestTeam;
	local ControlPoint Best;
	local Pawn P;
	local int i, j, k, nbest, n;
	local PlayerPawn player;

	// find winner
	BestTeam = Teams[0];

	if ((bMonsterTeam) && (MonsterTeamNum == MaxTeams))
		k = MaxTeams + 1;
	else
		k = MaxTeams;
	for ( i=1; i<k; i++ )
	{
		if ( int(Teams[i].Score) > int(BestTeam.Score) )
			BestTeam = Teams[i];
		else if ( int(Teams[i].Score) == int(BestTeam.Score) )
		{
			n = 0;
			nbest = 0;
			// check who has more points currently
			for ( j=0; j<CPCnt; j++ )
				if ( ControlPoints[j] != None )
				{
					if ( ControlPoints[j].ControllingTeam == BestTeam )
						nbest++;
					else if ( ControlPoints[j].ControllingTeam == Teams[i] )
						n++;
				}

			if ( n > nbest )
				BestTeam = Teams[i];
		}
	}

	GameReplicationInfo.GameEndedComments = TeamPrefix@BestTeam.TeamName@GameEndedMessage;

	ForEach AllActors(class'ControlPoint', Best)
		if ( Best.ControllingTeam == BestTeam )
			break;

	EndTime = Level.TimeSeconds + 3.0;
	for ( P=Level.PawnList; P!=None; P=P.nextPawn )
	{
		player = PlayerPawn(P);
		P.GotoState('GameEnded');
		if ( Player != None )
		{
			player.bBehindView = true;
			player.ViewTarget = Best;
			if (!bTutorialGame)
				PlayWinMessage(Player, (Player.PlayerReplicationInfo.Team == BestTeam.TeamIndex));
			player.ClientGameEnded();
		}
	}
	CalcEndStats();
	return true;
}

function CalcEndStats()
{
	EndStatsClass.Default.TotalGames++;
	EndStatsClass.Static.StaticSaveConfig();
}


function Timer()
{
	local ControlPoint CP;
	local int i, j, k;
	local float c;
	local PlayerReplicationInfo PRI;

	if ((!bGameEnded) && (!bTDM))
	{
		c = 0.2;
		if ( TimeLimit > 0 )
		{
			if ( RemainingTime < 0.25 * TimeLimit )
			{
				if ( RemainingTime < 0.1 * TimeLimit )
					c = 0.8;
				else
					c = 0.4;
			}
		}

		if ( !bRequireReady || (CountDown <= 0) )
			for (i=0; i<CPCnt; i++)
			{
				CP = ControlPoints[i];
				if ( (CP.ControllingTeam != None) && CP.bScoreReady )
				{
					CP.ControllingTeam.Score += c;
					CP.Controller.PlayerReplicationInfo.Score += c;
				}
			}
		if ((bMonsterTeam) && (MonsterTeamNum == MaxTeams))
			k = MaxTeams + 1;
		else
			k = MaxTeams;

		for (i=0; i<k; i++)
		{
			TCPCnt[i] = 0;
			for (j=0; j<CPCnt; j++)
			{
				if ((ControlPoints[j].ControllingTeam != None) && (ControlPoints[j].ControllingTeam.TeamIndex == i))
					TCPCnt[i]++;
			}
		}
		DomScoreEvent++;
		if (DomScoreEvent >= 5)
		{
			DomScoreEvent = 0;
			for (i=0; i<k; i++)
			{
				if (Teams[i].Score > 0)
				{
					if (Level.Game.WorldLog != None)
						Level.Game.WorldLog.LogSpecialEvent("dom_score_update", i, Teams[i].Score);
					if (Level.Game.LocalLog != None)
						Level.Game.LocalLog.LogSpecialEvent("dom_score_update", i, Teams[i].Score);
				}
			}
			for (i=0; i<32; i++)
			{
				PRI = GameReplicationInfo.PRIArray[i];
				if (PRI != None)
				{
					if (Level.Game.WorldLog != None)
						Level.Game.WorldLog.LogSpecialEvent("dom_playerscore_update", PRI.PlayerID, int(PRI.Score));
					if (Level.Game.LocalLog != None)
						Level.Game.LocalLog.LogSpecialEvent("dom_playerscore_update", PRI.PlayerID, int(PRI.Score));				
				}
			}
		}
		if ( GoalTeamScore > 0 )
			for ( i=0; i<k; i++ )
				if ( Teams[i].Score >= GoalTeamScore )
					EndGame("teamscorelimit");
	}

	Super.Timer();
}

function bool CanTranslocate(Bot aBot)
{
	if ( aBot.bNovice && (aBot.Skill < 2) )
		return false;
	return Super.CanTranslocate(aBot);
} 

function ClearControl(Pawn Other)
{
	local ControlPoint CP;
	local Pawn P, Pick;
	local int Num, i;

	// find a teammate
	if ( !Other.bIsPlayer || (Other.PlayerReplicationInfo.Team == 255) )
		return;

	for ( P=Level.PawnList; P!=None; P=P.NextPawn )
		if ( P.bIsPlayer && (P != Other) && (P.PlayerReplicationInfo.Team == Other.PlayerReplicationInfo.Team) )
		{
			Num++;
			if ( (Pick == None) || (Rand(Num) == 1) )
				Pick = P;
		}
	for (i=0; i<CPCnt; i++)
	{
		CP = ControlPoints[i];
		if (CP.ControllingTeam != None)
		{
			if ( CP.Controller == Other )
			{
				CP.Controller = Pick;
				CP.UpdateStatus();
			}
		}
	}
}
function Logout( pawn Exiting )
{
	ClearControl(Exiting);
	Super.Logout(Exiting);
}

function bool RestartPlayer( pawn aPlayer )	
{
	local Bot B;

	B = Bot(aPlayer);
	if ( (B != None) && (B.Orders == 'Defend') )
		B.SetOrders('Freelance', None);
	return Super.RestartPlayer(aPlayer);
}

function Actor SetDefenseFor(Bot aBot)
{
	local Actor Result;
	local int i, j;
	local NavigationPoint N;

	if ( ControlPoint(aBot.OrderObject) != None )
		return aBot.OrderObject;

	while (i<CPCnt)
	{
		if ( (ControlPoints[i].ControllingTeam != None)
			&& (ControlPoints[i].ControllingTeam.TeamIndex == aBot.PlayerReplicationInfo.Team) )
		{
			j++;
			if ( (Result == None) || ( FRand() < 1.0/float(j)) )
				Result = N;
		}	
		i++;
	}

	return Result;		
}

function bool FindSpecialAttractionFor(Bot aBot)
{
	local float bestweight, newweight;
	local ControlPoint Best, Near;
	local int i, count, maxdist, t;
	local bool bOrdered, bFound, bBehind;

	if (bTDM) return false;

	if ( aBot.LastAttractCheck == Level.TimeSeconds )
		return false;
	aBot.LastAttractCheck = Level.TimeSeconds;

	if ( aBot.Orders == 'Defend' )
	{
		if ( (aBot.OrderObject == None) || !aBot.OrderObject.IsA('ControlPoint') )
			aBot.Orders = 'FreeLance';
		else if ( (ControlPoint(aBot.OrderObject).ControllingTeam == None)
					|| (ControlPoint(aBot.OrderObject).ControllingTeam.TeamIndex != aBot.PlayerReplicationInfo.Team) )
		{
			if ( VSize(aBot.OrderObject.Location - aBot.Location) < 20 )
			{
				aBot.OrderObject.Touch(aBot);
				return false;
			}
			else if ( aBot.ActorReachable(aBot.OrderObject) )
			{
				bFound = true;
				aBot.MoveTarget = aBot.OrderObject;
			}
			else
			{
				aBot.MoveTarget = aBot.FindPathToward(aBot.OrderObject);
				bFound = ( aBot.MoveTarget != None );
			}
			if ( bFound )
			{
				if ( aBot.Enemy != None )
					aBot.bReadyToAttack = true;
				SetAttractionStateFor(aBot);
				return true;
			}
			return false;
		}
		else
			return false;					
	}
	// also "no movetarget"	in fallback		
	bOrdered = (aBot.Orders == 'Follow') || (aBot.Orders == 'Hold');
	if ( !bOrdered && bDumbdown && aBot.bDumbdown && !bNeutralPoints )
	{
		// dumbdown bot if its team isn't too far behind
		for ( i=0; i< MaxTeams; i++ )
			if ( Teams[i].score > Teams[aBot.PlayerReplicationInfo.Team].score + 20 )
				bBehind = true;
		bOrdered = !bBehind;
	}
				
	if ( bOrdered || (aBot.Enemy != None) || (aBot.Weapon == None) 
		|| (aBot.Weapon.AIRating < 0.5) || (aBot.Health < 70) )
	{
		if ( bOrdered )
			MaxDist = ChkRad;
		else
			MaxDist = ChkRad + (ChkRad * 0.20);
		// change nearby enemy or neutral controlpoint
		i = 0;
		bNeutralPoints = false;
		while (i<CPCnt)
		{
			if ( ((ControlPoints[i].ControllingTeam == None) 
				|| (ControlPoints[i].ControllingTeam.TeamIndex != aBot.PlayerReplicationInfo.Team))
				&& (VSize(aBot.Location - ControlPoints[i].Location) < MaxDist)
				&& aBot.LineOfSightTo(ControlPoints[i]) )
			{
				if ( ControlPoints[i].ControllingTeam == None )
				{
					bNeutralPoints = true;
					if ( bOrdered && (aBot.Orders != 'Follow') && (aBot.Orders != 'Hold') )
					{
						aBot.bDumbDown = false; 
						bOrdered = false;
					}
				}
									
				if ( VSize(ControlPoints[i].Location - aBot.Location) < 20 )
				{
					ControlPoints[i].Touch(aBot);
					return false;
				}
				else if ( aBot.ActorReachable(ControlPoints[i]) )
				{
					bFound = true;
					aBot.MoveTarget = ControlPoints[i];
				}
				else if ( !bOrdered )
				{
					aBot.OrderObject = ControlPoints[i];
					BotReplicationInfo(aBot.PlayerReplicationInfo).OrderObject = None;
					aBot.MoveTarget = aBot.FindPathToward(ControlPoints[i]);
					bFound = ( aBot.MoveTarget != None );
				}
				if ( bFound )
				{
					if ( aBot.Enemy != None )
						aBot.bReadyToAttack = true;
					SetAttractionStateFor(aBot);
					return true;
				}
			}	
			i++;
		}
		if ( bOrdered || (aBot.Enemy == None) )
			return false;

		i = 0;
		while (i<CPCnt)
		{
			if ( (ControlPoints[i].ControllingTeam == None) 
				|| (ControlPoints[i].ControllingTeam.TeamIndex != aBot.PlayerReplicationInfo.Team) )
				Count--;
			else
				Count++;
			i++;
		}
		if ( Count > 0 )
			return false; // already have an advantage in control points
	}

	//log("Find Special Attraction for"@aBot@"in state"@aBot.GetStateName());

	Best = ControlPoint(aBot.OrderObject);
	if ( (Best == None)
		|| ((Best.ControllingTeam != None)
			&& (Best.ControllingTeam.TeamIndex == aBot.PlayerReplicationInfo.Team)))
	{
		i = 0; // missing in botpack.Domination.....
		bestweight = 10000000;
		while (i<CPCnt)
		{
			if ( ControlPoints[i].ControllingTeam == None )
				newweight = VSize(ControlPoints[i].location - aBot.location) * 0.1;
			else if ( (ControlPoints[i].ControllingTeam.TeamIndex != aBot.PlayerReplicationInfo.Team) )
			{
				newweight = VSize(ControlPoints[i].location - aBot.location) + 2 * Abs(ControlPoints[i].Location.Z - aBot.Location.Z);
				newweight *= (0.8 + 0.4 * FRand());
			}
			else 
				newweight = 90000000;

			if ( newweight < bestweight )
			{
				bestweight = newweight;
				Best = ControlPoints[i];
			}
			i++;
		}
	}

	if ( Best != None )
	{
		BotReplicationInfo(aBot.PlayerReplicationInfo).OrderObject = None;
		aBot.OrderObject = Best;
		if ( VSize(Best.Location - aBot.Location) < 20 )
		{
			aBot.OrderObject = None;
			Best.Touch(aBot);
			return false;
		}
		else if ( aBot.ActorReachable(Best) )
			aBot.MoveTarget = Best;
		else
			aBot.MoveTarget = aBot.FindPathToward(Best);

		if ( aBot.MoveTarget != None )
		{
			if ( aBot.bVerbose )
				log(aBot$" moving toward "$Best$" using "$aBot.MoveTarget);
			SetAttractionStateFor(aBot);
			return true;
		}
		else 
		{
			if ( FRand() < 0.3 )
				aBot.OrderObject = None;
			if ( aBot.bVerbose )
				log(aBot@"no path to"@Best.PointName);
		}
			
	}
	else if ( aBot.bVerbose )
		log(aBot@"found no best control point");
	return false;
}

function SetBotOrders(Bot NewBot)
{
	local Pawn P, L;
	local int num, total;
	local Bot B;

	NewBot.SetOrders('Freelance', None, true);
}				 

function EndGame( string Reason )
{
	local int i, k;
	local PlayerReplicationInfo PRI;

	if ((bMonsterTeam) && (MonsterTeamNum == MaxTeams))
		k = MaxTeams + 1;
	else
		k = MaxTeams;

	for (i=0; i<K; i++)
	{
		if (Teams[i].Score > 0)
		{
			if (Level.Game.WorldLog != None)
				Level.Game.WorldLog.LogSpecialEvent("dom_score_update", i, Teams[i].Score);
			if (Level.Game.LocalLog != None)
				Level.Game.LocalLog.LogSpecialEvent("dom_score_update", i, Teams[i].Score);
		}
	}
	for (i=0; i<32; i++)
	{
		PRI = GameReplicationInfo.PRIArray[i];
		if (PRI != None)
		{
			if (Level.Game.WorldLog != None)
				Level.Game.WorldLog.LogSpecialEvent("dom_playerscore_update", PRI.PlayerID, int(PRI.Score));
			if (Level.Game.LocalLog != None)
				Level.Game.LocalLog.LogSpecialEvent("dom_playerscore_update", PRI.PlayerID, int(PRI.Score));				
		}
	}
	Super.EndGame( Reason );
}

defaultproperties
{
     bDumbDown=False
     ExtraControlPoints=3
     bScoreSPKills=True
     bScoreSPvsSP=False
     bNegScoring=False
     bScoreTeamKills=True
     bMonsterTeam=True
     MonsterTeamNumber=255
}
