class C2DCP extends ControlPoint;

var CPDummy CPDum;
var bool bStarted, bDOM;

function PostBeginPlay()
{
	Super.PostBeginPlay();
	if (!bDOM) SetTimer(1.0, true); else SetTimer(2.0, true);
}

function Timer()
{
	local int Fcnt;
	local ScriptedPawn Sp;

	if (!bStarted)
	{
		if ((BP5(Level.Game).TimeLimit != 0) && (BP5(Level.Game).GameReplicationInfo.RemainingTime == (BP5(Level.Game).TimeLimit * 60)))
			return;
		if ((BP5(Level.Game).TimeLimit == 0) && (BP5(Level.Game).GameReplicationInfo.ElapsedTime == 0))
			return;
		bStarted = True;
	}

	if (!bDOM)
	{
		ForEach RadiusActors(class'ScriptedPawn', Sp, BP5(Level.Game).ChkRad, Self.Location)
		{
			if (Sp.Enemy == None) { AttackABot(Sp, BP5(Level.Game).ChkRad); Break; }
		}
		Return;
	}

	ScoreTime--;
	if (ScoreTime > 0)
		bScoreReady = false;
	else 
	{
		ScoreTime = 0;
		bScoreReady = true;
	}

	if ((!BP5(Level.Game).bMonsterTeam) || ((ControllingTeam != None) && (Controller.PlayerReplicationInfo.Team == BP5(Level.Game).MonsterTeamNum)))
	{
		Return;
	}

	Fcnt = 0;
	if ((ControllingTeam == None) || (Controller.PlayerReplicationInfo.Team != BP5(Level.Game).MonsterTeamNum))
	{
		ForEach RadiusActors(class'ScriptedPawn', Sp, BP5(Level.Game).ChkRad, Self.Location)
		{
			if ((VSize(Self.Location - Sp.Location) > 46) && ((Sp.Enemy == None) || ((Sp.Enemy != CPDum) && (VSize(Self.Location - Sp.Location) < VSize(Sp.Location - Sp.Enemy.Location)) && (FCnt < 3))))
			{
				Sp.bHasRangedAttack = False;
				Sp.MeleeRange = 1.0;
				Sp.OldEnemy = None;
				Sp.Enemy = CPDum;
				Sp.Hated = CPDum;
				Sp.SetEnemy(CPDum);
				Sp.gotostate('Attacking');
				FCnt++;
				If (FCnt > 4) break;
			}
		}
	}
}

function Touch(Actor Other)
{
	local Bot B;
	local ScriptedPawn Sp;

	if ( !Other.bIsPawn || !Level.Game.IsA('Domination') )
		return;

	if (Pawn(Other).bIsPlayer)
	{
		Controller = Pawn(Other);
	}
	else
	{
		if (ScriptedPawn(Other) != None)
		{
			Controller = BP5(Level.Game).Dummy;
			ForEach RadiusActors(class'ScriptedPawn', Sp, BP5(Level.Game).ChkRad, Self.Location)
			{
				Sp.bHasRangedAttack = Sp.default.bHasRangedAttack;
				Sp.MeleeRange = Sp.default.MeleeRange;
				if (Sp.Enemy == CPDum)
					AttackABot(Sp, BP5(Level.Game).ChkRad);
			}
		}
	}
	if ( (ScriptedPawn(Other) == None) && Controller.IsA('Bot') && ((Controller.MoveTarget == self) || (Controller.MoveTarget == CPDum)) )
		Controller.MoveTimer = -1.0; // stop moving toward this
	UpdateStatus();
}

function AttackABot(ScriptedPawn M, float AttackRad)
{
	local Bot B;
	local float Cdist;

	Cdist = AttackRad * 0.20;
	while (Cdist <= AttackRad)
	{
		ForEach RadiusActors(class'Bot', B, Cdist, M.Location)
		{
			if (BP5(Level.Game).MonsterTeamNum != B.PlayerReplicationInfo.Team)
			{
				M.Enemy = B;
				M.Hated = B;
				M.SetEnemy(B);
				M.gotostate('Attacking');
				Cdist = AttackRad;
				break;
			} // Set ATTITUDE to bot here....
		}
		Cdist *= 1.20;
	}

	if ((M.Enemy == None) || (M.Enemy == CPDum))
	{
		M.Enemy = None;
		M.Hated = None;
		M.SetEnemy(None);
		M.gotostate('Wandering');
	}
}

defaultproperties
{
     bStatic=False
     bNoDelete=False
     bCollideWhenPlacing=False
}